#include <gmodule.h>

#define TYPE_PLAYER   0
#define TYPE_ANALYSIS 1
#define TYPE_LOADER   2
#define TYPE_ALL      3

typedef struct _generic_plugin {
   char *id;
   char *version;
   char *copyright;
   GModule *handle;
   char *soname;
   int loaded;
   int type;
   void *data;
   struct _generic_plugin *next;
} GenericPlugin;


struct analysis_plugin {
   int (*init) (Window win, int w, int h);
   void (*do_analysis) (char *buffer, int size);
   void (*close) (void);
   void (*config) (char *left, char *right);
   int size;
   GenericPlugin *parent;
};

extern void *__Emalloc(int size, const char *file, int line);
extern void *__Erealloc(void *ptr, int size, const char *file, int line);
extern void *__Ecalloc(int num, int size, const char *file, int line);
extern void __Efree(void *ptr, const char *file, int line);
extern char *duplicate(char *s);

#if defined(__FILE__) && defined(__LINE__)
#define Efree(x) __Efree(x, __FILE__, __LINE__)
#define Emalloc(x) __Emalloc(x, __FILE__, __LINE__)
#define Erealloc(x, y) __Erealloc(x, y, __FILE__, __LINE__)
#define Ecalloc(x, y) __Ecalloc(x, y, __FILE__, __LINE__)        
#else
#define Efree(x) free(x)
#define Emalloc(x) malloc(x)
#define Erealloc(x, y) realloc(x, y)
#define Ecalloc(x, y) calloc(x, y)
#endif

